(function (Drupal) {
  Drupal.smartContent = Drupal.smartContent || {};
  Drupal.smartContent.plugin = Drupal.smartContent.plugin || {};
  Drupal.smartContent.plugin.Field = Drupal.smartContent.plugin.Field || {};
  Drupal.smartContent.plugin.ConditionType = Drupal.smartContent.plugin.ConditionType || {};

  let promiseRaceMatch = function (promises, match) {
    if (promises.length < 1) {
      return false;
    }

    // There is no way to know which promise is false, so we map it to a new
    // promise to return the index when it fails.
    let indexPromises = promises.map((p, index) => p.then(() => index));

    return Promise.race(indexPromises).then(async(index) => {
      let p = promises.splice(index, 1)[0];
      let result = await p;
      if (result === match) {
        return p;
      }
      else {
        if (promises.length < 1) {
          return !match;
        }
        return promiseRaceMatch(promises, match);
      }
    });
  };

  Drupal.smartContent.plugin.Field['smart_segment'] = function (condition, smartContentManager) {
    let conditions = [];
    // todo: how to handle rejection? early returns/processing?
    Object.keys(condition.conditions).forEach(key => {
      let promise = smartContentManager.processCondition(condition.conditions[key]);
      conditions.push(promise);
    });
    // If group is AND, early return as soon as a false match comes back.
    return promiseRaceMatch(conditions, false);
  };


  Drupal.smartContent.plugin.ConditionType['plugin:smart_segment'] = function (condition, value) {
    return value;
  };

})(Drupal);
