const path = require('path');
const webpack = require('webpack');

module.exports = {
  entry: {
    'js/condition.smart_segment': './js/condition.smart_segment.es6.js'
  },

  output: {
    path: path.resolve(__dirname),
    filename: '[name].js',
  },

  module: {
    rules: [
      {
        test: /\.js$/,
        exclude: [/node_modules/],
        use: [
          {
            loader: 'babel-loader',
            options: {
              presets: [
                ['@babel/preset-env', {
                  modules: false,
                  targets: {
                    ie: 11,
                  },
                  useBuiltIns: 'usage',
                  corejs: 3,
                }],
              ],
            },
          },
        ],
      },
    ],
  },

  plugins: [
    new webpack.BannerPlugin({
      banner: 'DO NOT EDIT THIS FILE.',
    }),
  ],

}
